Sketcher SketchObject
Introduction
A Sketcher SketchObject, or formally a Sketcher::SketchObject
, is the base element to create 2D objects with the Sketcher Workbench.
The Sketcher::SketchObject
is derived from the Part Part2DObject, which means it is a Part Feature object specialized for 2D geometry. Like the Part2DObject, the SketchObject can be attached to planes and faces. In addition, the SketchObject can handle geometrical constraints.
Simplified diagram of the relationships between the core objects in FreeCAD
Usage
See Sketcher NewSketch.
Properties
See Property for all property types that scripted objects can have.
The Sketcher SketchObject (Sketcher::SketchObject
class) is derived from the Part Part2DObject (Part::Part2DObject
class) and inherits all its properties.
The Sketcher SketchObject also has the following additional properties in the property editor. Hidden properties can be shown by using the Show all command in the context menu of the property editor.
Data
Sketch
- Data (Hidden)Geometry (
GeometryList
): a list of Part geometries that exist inside the sketch. - DataConstraints: named constraints, if they exist; otherwise it is an empty list
[]
. - DataExternal Geometry (
LinkSubList
): a list of Part geometries outside this Sketch that are used for reference. - Data (Hidden)Fully Constrained (
Bool
): (read-only) iftrue
the sketch is fully constrained.
View
Auto Constraints
- ViewAutoconstraints (
Bool
): iftrue
constraints are automatically added when geometry is drawn. - ViewAvoid Redundant (
Bool
): iftrue
redundant auto-constraints are avoided.
Grid
- ViewGrid Auto (
Bool
): iftrue
the grid is resized based on the boundingbox of the geometry of the sketch. - ViewGrid Size (
Length
): the size of the spacing of the local grid lines in the 3D view; it defaults to10 mm
. - ViewShow Grid (
Bool
): iftrue
a grid local to the object will be displayed in the 3D view. This grid is independent of the Draft Grid.
Visibility automation
- ViewEditing Workbench (
String
): name of the workbench to activate when editing the sketch; it defaults toSketcherWorkbench
. - ViewForce Ortho (
Bool
): iftrue
the camera will be forced to orthographic view mode when the sketch is opened. - ViewHide Dependent (
Bool
): iftrue
all objects that depend on the sketch are hidden when the sketch is opened. - ViewRestore Camera (
Bool
): iftrue
the camera position is saved before opening the sketch, and is restored after closing it. - ViewSection View (
Bool
): iftrue
only (parts of) objects behind the sketch plane are visible while the sketch is being edited. - ViewShow Links (
Bool
): iftrue
all objects used in links to external geometry are shown when the sketch is opened. - ViewShow Support (
Bool
): iftrue
all objects this sketch is attached to are shown when the sketch is opened. - View (Hidden)Tempo Vis (
PythonObject
): a custom class associated with this object, that handles hiding and showing other objects when opening and closing the sketch.
Scripting
See also: FreeCAD Scripting Basics and scripted objects.
See Part Feature for the general information on adding objects to the document.
A SketchObject is created with the addObject()
method of the document.
import FreeCAD as App
doc = App.newDocument()
obj = App.ActiveDocument.addObject("Sketcher::SketchObject", "Sketch")
obj.Label = "Custom label"
For Python subclassing you should create the Sketcher::SketchObjectPython
object.
import FreeCAD as App
doc = App.newDocument()
obj = App.ActiveDocument.addObject("Sketcher::SketchObjectPython", "CustomSketch")
obj.Label = "Custom label"
- General: Create sketch, Edit sketch, Attach sketch, Reorient sketch, Validate sketch, Merge sketches, Mirror sketch, Leave sketch, View sketch, View section, Toggle grid, Toggle snap, Configure rendering order, Stop operation
- Sketcher geometries: Point, Polyline, Line, Arc, Arc by 3 points, Arc of ellipse, Arc of hyperbola, Arc of parabola, Circle, Circle by 3 points, Ellipse, Ellipse by 3 points, Rectangle, Centered rectangle, Rounded rectangle, Triangle, Square, Pentagon, Hexagon, Heptagon, Octagon, Regular polygon, Slot, Arc slot, B-spline by control points, Periodic B-spline by control points, B-spline by knots, Periodic B-spline by knots, Toggle construction geometry
- Sketcher constraints:
- Dimensional constraints: Dimension, Horizontal distance, Vertical distance, Distance, Auto radius/diameter, Radius, Diameter, Angle, Lock
- Geometric constraints: Coincident (unified), Coincident, Point on object, Horizontal/vertical, Horizontal, Vertical, Parallel, Perpendicular, Tangent or collinear, Equal, Symmetric, Block
- Other constraints: Refraction (Snell's law)
- Constraint tools: Toggle driving/reference constraint, Activate/deactivate constraint
- Sketcher tools: Fillet, Chamfer, Trim, Split, Extend, External geometry, Carbon copy, Select origin, Select horizontal axis, Select vertical axis, Array transform, Polar transform, Scale transform, Offset geometry, Symmetry, Remove axes alignment, Delete all geometry, Delete all constraints
- Sketcher B-spline tools: Convert geometry to B-spline, Increase B-spline degree, Decrease B-spline degree, Increase knot multiplicity, Decrease knot multiplicity, Insert knot, Join curves
- Sketcher visual: Select unconstrained DoF, Select associated constraints, Select associated geometry, Select redundant constraints, Select conflicting constraints, Show/hide circular helper for arcs, Show/hide B-spline degree, Show/hide B-spline control polygon, Show/hide B-spline curvature comb, Show/hide B-spline knot multiplicity, Show/hide B-spline control point weight, Show/hide internal geometry, Switch virtual space
- Additional: Sketcher Dialog, Preferences, Sketcher scripting
- Core: App DocumentObject
- Basic: App FeaturePython, App GeoFeature, Part Feature, Mesh Feature, Fem FemMeshObject
- Internal shapes: Part TopoShape, Mesh MeshObject, Fem FemMesh
- Structure: App DocumentObjectGroup (Std Group), App Part (Std Part), App Link (Std LinkMake)
- Derived: Part Part2DObject, Sketcher SketchObject, PartDesign Body, PartDesign Feature

- Getting started
- Installation: Download, Windows, Linux, Mac, Additional components, Docker, AppImage, Ubuntu Snap
- Basics: About FreeCAD, Interface, Mouse navigation, Selection methods, Object name, Preferences, Workbenches, Document structure, Properties, Help FreeCAD, Donate
- Help: Tutorials, Video tutorials
- Workbenches: Std Base, Assembly, BIM, CAM, Draft, FEM, Inspection, Material, Mesh, OpenSCAD, Part, PartDesign, Points, Reverse Engineering, Robot, Sketcher, Spreadsheet, Surface, TechDraw, Test Framework
- Hubs: User hub, Power users hub, Developer hub